from pyranges_db.methods import get_ftp_file

from pyranges_db import ucsc
from pyranges_db import gencode
from pyranges_db import ensembl
from pyranges_db import gwas_catalog

import pyranges as pr
exons, cpg = pr.data.exons(), pr.data.cpg()

exons
# +--------------+-----------+-----------+----------------------------------------+-----------+--------------+
# | Chromosome   | Start     | End       | Name                                   | Score     | Strand       |
# | (category)   | (int32)   | (int32)   | (object)                               | (int64)   | (category)   |
# |--------------+-----------+-----------+----------------------------------------+-----------+--------------|
# | chrX         | 135721701 | 135721963 | NR_038462_exon_0_0_chrX_135721702_f    | 0         | +            |
# | chrX         | 135574120 | 135574598 | NM_001727_exon_2_0_chrX_135574121_f    | 0         | +            |
# | chrX         | 47868945  | 47869126  | NM_205856_exon_4_0_chrX_47868946_f     | 0         | +            |
# | chrX         | 77294333  | 77294480  | NM_000052_exon_17_0_chrX_77294334_f    | 0         | +            |
# | ...          | ...       | ...       | ...                                    | ...       | ...          |
# | chrY         | 15409586  | 15409728  | NR_047633_exon_3_0_chrY_15409587_r     | 0         | -            |
# | chrY         | 15478146  | 15478273  | NR_047634_exon_18_0_chrY_15478147_r    | 0         | -            |
# | chrY         | 15360258  | 15361762  | NR_047601_exon_0_0_chrY_15360259_r     | 0         | -            |
# | chrY         | 15467254  | 15467278  | NM_001258270_exon_13_0_chrY_15467255_r | 0         | -            |
# +--------------+-----------+-----------+----------------------------------------+-----------+--------------+
# Stranded PyRanges object has 1,000 rows and 6 columns from 2 chromosomes.
# For printing, the PyRanges was sorted on Chromosome and Strand.

cpg
# +--------------+-----------+-----------+-----------+
# | Chromosome   | Start     | End       | CpG       |
# | (category)   | (int32)   | (int32)   | (int64)   |
# |--------------+-----------+-----------+-----------|
# | chrX         | 64181     | 64793     | 62        |
# | chrX         | 69133     | 70029     | 100       |
# | chrX         | 148685    | 149461    | 85        |
# | chrX         | 166504    | 167721    | 96        |
# | ...          | ...       | ...       | ...       |
# | chrY         | 28555535  | 28555932  | 32        |
# | chrY         | 28773315  | 28773544  | 25        |
# | chrY         | 59213794  | 59214183  | 36        |
# | chrY         | 59349266  | 59349574  | 29        |
# +--------------+-----------+-----------+-----------+
# Unstranded PyRanges object has 1,077 rows and 4 columns from 2 chromosomes.
# For printing, the PyRanges was sorted on Chromosome.

cpg.join(exons[["Name"]])
# +--------------+-----------+-----------+-----------+-----------+-----------+----------------------------------------+--------------+
# | Chromosome   | Start     | End       | CpG       | Start_b   | End_b     | Name                                   | Strand       |
# | (category)   | (int32)   | (int32)   | (int64)   | (int32)   | (int32)   | (object)                               | (category)   |
# |--------------+-----------+-----------+-----------+-----------+-----------+----------------------------------------+--------------|
# | chrX         | 584563    | 585326    | 66        | 585078    | 585337    | NM_000451_exon_0_0_chrX_585079_f       | +            |
# | chrX         | 10094050  | 10094406  | 26        | 10094153  | 10094346  | NM_015691_exon_14_0_chrX_10094154_f    | +            |
# | chrX         | 13587648  | 13588221  | 49        | 13587693  | 13588054  | NM_001167890_exon_0_0_chrX_13587694_f  | +            |
# | chrX         | 17755053  | 17756648  | 117       | 17755568  | 17755800  | NM_001037535_exon_0_0_chrX_17755569_f  | +            |
# | ...          | ...       | ...       | ...       | ...       | ...       | ...                                    | ...          |
# | chrY         | 15591259  | 15591720  | 33        | 15591393  | 15592550  | NR_047610_exon_27_0_chrY_15591394_r    | -            |
# | chrY         | 15591259  | 15591720  | 33        | 15591393  | 15592550  | NR_047607_exon_29_0_chrY_15591394_r    | -            |
# | chrY         | 15591259  | 15591720  | 33        | 15591393  | 15592550  | NM_001258269_exon_29_0_chrY_15591394_r | -            |
# | chrY         | 15591259  | 15591720  | 33        | 15591393  | 15592550  | NR_047599_exon_28_0_chrY_15591394_r    | -            |
# +--------------+-----------+-----------+-----------+-----------+-----------+----------------------------------------+--------------+
# Stranded PyRanges object has 79 rows and 8 columns from 2 chromosomes.
# For printing, the PyRanges was sorted on Chromosome and Strand.

cpg.join(exons[["Name"]]).drop(like="_b")
# +--------------+-----------+-----------+-----------+----------------------------------------+--------------+
# | Chromosome   | Start     | End       | CpG       | Name                                   | Strand       |
# | (category)   | (int32)   | (int32)   | (int64)   | (object)                               | (category)   |
# |--------------+-----------+-----------+-----------+----------------------------------------+--------------|
# | chrX         | 584563    | 585326    | 66        | NM_000451_exon_0_0_chrX_585079_f       | +            |
# | chrX         | 10094050  | 10094406  | 26        | NM_015691_exon_14_0_chrX_10094154_f    | +            |
# | chrX         | 13587648  | 13588221  | 49        | NM_001167890_exon_0_0_chrX_13587694_f  | +            |
# | chrX         | 17755053  | 17756648  | 117       | NM_001037535_exon_0_0_chrX_17755569_f  | +            |
# | ...          | ...       | ...       | ...       | ...                                    | ...          |
# | chrY         | 15591259  | 15591720  | 33        | NR_047610_exon_27_0_chrY_15591394_r    | -            |
# | chrY         | 15591259  | 15591720  | 33        | NR_047607_exon_29_0_chrY_15591394_r    | -            |
# | chrY         | 15591259  | 15591720  | 33        | NM_001258269_exon_29_0_chrY_15591394_r | -            |
# | chrY         | 15591259  | 15591720  | 33        | NR_047599_exon_28_0_chrY_15591394_r    | -            |
# +--------------+-----------+-----------+-----------+----------------------------------------+--------------+
# Stranded PyRanges object has 79 rows and 6 columns from 2 chromosomes.
# For printing, the PyRanges was sorted on Chromosome and Strand.
